#include <iostream>
using namespace std;
long long a[200003];
long long prefiksna[200003];
long long pref[200003];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long n, q, l, r, s;
    int p = 0;
    int k, e;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        if (a[i] != 1 && a[i] != 2)
            p = 1;
    }
    cin >> q;
    if (p == 1)
    {
        prefiksna[0] = 0;
        for (int i = 0; i < n - 1; i++)
        {
            if (a[i] <= a[i + 1])
            {
                a[i] = 0;
            }
            else
            {
                a[i] = 1;
            }
            prefiksna[i + 1] = prefiksna[i] + a[i];
        }
        for (int i = 0; i < q; i++)
        {
            cin >> l >> r;
            s = prefiksna[r - 1] - prefiksna[l - 1];
            if (s >= 2)
            {
                cout << "NE" << endl;
            }
            else
            {
                cout << "DA" << endl;
            }
        }
    }
    else
    {
        int w;
        prefiksna[0] = 0;
        for (int i = 0; i < n - 1; i++)
        {
            if (a[i] != a[i + 1])
            {
                w = 1;
            }
            else
            {
                w = 0;
            }
            prefiksna[i + 1] = prefiksna[i] + w;
        }
        pref[0] = 0;
        for (int i = 0; i < n - 1; i++)
        {
            if (a[i] == 2 && a[i + 1] == 2)
            {
                w = 1;
            }
            else
            {
                w = 0;
            }
            pref[i + 1] = pref[i] + w;
        }
        for (int i = 0; i < q; i++)
        {
            cin >> l >> r;
            k = 0;
            e = 0;
            k = prefiksna[r - 1] - prefiksna[l - 1];
            e = pref[r - 1] - pref[l - 1];
            if (l == r)
            {
                cout << "DA" << endl;
            }
            else if (a[l - 1] == 2 && a[l] == 2 && k != 0)
            {
                cout << "NE" << endl;
            }
            else if (a[l - 1] == 2 && k <= 2)
            {
                cout << "DA" << endl;
            }
            else if(a[l - 1] == 2)
            {
                cout << "NE" << endl;
            }
            else if(a[l - 1] == 1 && e==0 && k<=3 )
            {
                cout << "DA" << endl;
            }
            else if(a[l - 1] == 1 && e == 0 && k > 3)
            {
                cout << "NE" << endl;
            }
            else
            {
                cout << "NE" << endl;
            }
        }
    }
    return 0;
}